Index: /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 2195)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app.c	(revision 2196)
@@ -250,5 +250,6 @@
     puts  ("Media Transport Options:");
     puts  ("  --use-ice           Enable ICE (default:no)");
-    puts  ("  --ice-no-host       Disable ICE host candidates");
+    puts  ("  --ice-no-host       Disable ICE host candidates (default: no)");
+    puts  ("  --ice-no-rtcp       Disable RTCP component in ICE (default: no)");
     puts  ("  --rtp-port=N        Base port to try for RTP (default=4000)");
     puts  ("  --rx-drop-pct=PCT   Drop PCT percent of RX RTP (for pkt lost sim, default: 0)");
@@ -457,6 +458,6 @@
 	   OPT_AUTO_CONF, OPT_CLOCK_RATE, OPT_SND_CLOCK_RATE, OPT_STEREO,
 	   OPT_USE_ICE, OPT_USE_SRTP, OPT_SRTP_SECURE,
-	   OPT_USE_TURN, OPT_ICE_NO_HOST, OPT_TURN_SRV, OPT_TURN_TCP,
-	   OPT_TURN_USER, OPT_TURN_PASSWD,
+	   OPT_USE_TURN, OPT_ICE_NO_HOST, OPT_ICE_NO_RTCP, OPT_TURN_SRV, 
+	   OPT_TURN_TCP, OPT_TURN_USER, OPT_TURN_PASSWD,
 	   OPT_PLAY_FILE, OPT_PLAY_TONE, OPT_RTP_PORT, OPT_ADD_CODEC, 
 	   OPT_ILBC_MODE, OPT_REC_FILE, OPT_AUTO_REC,
@@ -530,4 +531,5 @@
 	{ "use-turn",	0, 0, OPT_USE_TURN},
 	{ "ice-no-host",0, 0, OPT_ICE_NO_HOST},
+	{ "ice-no-rtcp",0, 0, OPT_ICE_NO_RTCP},
 	{ "turn-srv",	1, 0, OPT_TURN_SRV},
 	{ "turn-tcp",	0, 0, OPT_TURN_TCP},
@@ -948,4 +950,8 @@
 	    break;
 
+	case OPT_ICE_NO_RTCP:
+	    cfg->media_cfg.ice_no_rtcp = PJ_TRUE;
+	    break;
+
 	case OPT_TURN_SRV:
 	    cfg->media_cfg.turn_server = pj_str(pj_optarg);
@@ -1555,4 +1561,7 @@
     if (config->media_cfg.ice_no_host_cands)
 	pj_strcat2(&cfg, "--ice-no-host\n");
+
+    if (config->media_cfg.ice_no_rtcp)
+	pj_strcat2(&cfg, "--ice-no-rtcp\n");
 
     if (config->media_cfg.turn_server.slen) {
Index: /pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/305_ice_comp_1_2.py
===================================================================
--- /pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/305_ice_comp_1_2.py	(revision 2196)
+++ /pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/305_ice_comp_1_2.py	(revision 2196)
@@ -0,0 +1,12 @@
+# $Id$
+#
+from inc_cfg import *
+
+# Different number of ICE components
+test_param = TestParam(
+		"Callee=use ICE, caller=use ICE",
+		[
+			InstanceParam("callee", "--null-audio --use-ice --max-calls=1 --ice-no-rtcp", enable_buffer=True),
+			InstanceParam("caller", "--null-audio --use-ice --max-calls=1", enable_buffer=True)
+		]
+		)
Index: /pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/305_ice_comp_2_1.py
===================================================================
--- /pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/305_ice_comp_2_1.py	(revision 2196)
+++ /pjproject/trunk/pjsip-apps/src/test-pjsua/scripts-call/305_ice_comp_2_1.py	(revision 2196)
@@ -0,0 +1,12 @@
+# $Id$
+#
+from inc_cfg import *
+
+# Different number of ICE components
+test_param = TestParam(
+		"Callee=use ICE, caller=use ICE",
+		[
+			InstanceParam("callee", "--null-audio --use-ice --max-calls=1", enable_buffer=True),
+			InstanceParam("caller", "--null-audio --use-ice --max-calls=1 --ice-no-rtcp", enable_buffer=True)
+		]
+		)
Index: /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 2195)
+++ /pjproject/trunk/pjsip/include/pjsua-lib/pjsua.h	(revision 2196)
@@ -4102,4 +4102,11 @@
 
     /**
+     * Disable RTCP component.
+     *
+     * Default: no
+     */
+    pj_bool_t		ice_no_rtcp;
+
+    /**
      * Enable TURN relay candidate in ICE.
      */
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 2195)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_media.c	(revision 2196)
@@ -759,5 +759,5 @@
 
 	comp_cnt = 1;
-	if (PJMEDIA_ADVERTISE_RTCP)
+	if (PJMEDIA_ADVERTISE_RTCP && !pjsua_var.media_cfg.ice_no_rtcp)
 	    ++comp_cnt;
 